﻿enum EHeliState { hsOnBoat, hsOnLand, hsFlying };

class CGameController;
class CIsland;
class CBullet;
class CTurret;
class CRocket;

class CCombat
{
public:
	CCombat(Obelisk::IObelisk* aObelisk, CGameController* aOwner, CIsland* aIsland);
	~CCombat();

	bool Update();
	void Render();

private:
	Obelisk::IObelisk *mObelisk;
	CGameController *mOwner;
	CIsland *mIsland;

	int mNumHelis;

	float mProjectionMatrix[16];

	float mCamera;

	int mForTheWin;

	void Die();
	int mDeathCountdown;

	int mHP;
	float mHeliX;
	float mHeliY;
	float mHeliDir;
	float mHeliFrame;
	float mHeliFrameCount;
	EHeliState mHeliState;
	void ResetHeli();

	Obelisk::CCollection<CBullet> mBullets;
	int mBulletCountdown;

	Obelisk::CCollection<CTurret> mTurrets;
	Obelisk::CCollection<CRocket> mRockets;
};