﻿#include "Obelisk.h"

#include "CScriptEngine.h"
#include "IScript.h"
#include "CScriptFinalCutscene.h"

using namespace Obelisk;



CScriptFinalCutscene::CScriptFinalCutscene()
{
	mStage = 0;
	mLevel = 0;
}



bool CScriptFinalCutscene::Update(bool& aResult, IObelisk* aObelisk, CScriptEngine* aEngine)
{
	aResult = true;
	if ((aObelisk->MouseButtonClicked(false) || aEngine->IsEnterPressed()))
	{
		if (mStage < 5)
			mStage++;
	}
	if (mStage == 5)
	{
		if (++mLevel == 430)
		{
			aEngine->Win();
			return true;
		}
	}
	return false;
}



void CScriptFinalCutscene::Render(IObelisk* aObelisk, CScriptEngine* aEngine)
{
	switch (mStage)
	{
		case 0:
			aEngine->ShowProfileCut(pBadGuy, 1);
			aEngine->ShowTextCut(1, 0, SL("Bad Guy:"));
			aEngine->ShowTextCut(1, 1, SL("Well. It looks like you found me Aaron..."));
			break;
		case 1:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("Commander A. R. Sole:"));
			aEngine->ShowTextCut(0, 1, SL("..."));
			break;
		case 2:
			aEngine->ShowProfileCut(pBadGuy, 1);
			aEngine->ShowTextCut(1, 0, SL("Bad Guy:"));
			aEngine->ShowTextCut(1, 1, SL("There is something my mother always"));
			aEngine->ShowTextCut(1, 2, SL("wanted you to know..."));
			break;
		case 3:
			aEngine->ShowProfileCut(pBadGuy, 1);
			aEngine->ShowTextCut(1, 0, SL("Aaron..."));
			break;
		case 4:
			aEngine->ShowProfileCut(pBadGuy, 1);
			aEngine->ShowTextCut(1, 0, SL("You are my brother."));
			break;
		case 5:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("Commander Aaron. R. Sole:"));
			aEngine->ShowTextCut(0, 1, SL("NOOOOOOOOOOOOOOOOOOOOOO"));
			aObelisk->SetAlpha(mLevel >= 350 ? 1 : (float)mLevel / 450);
			aEngine->DrawRect(0, 0, 1024, 768, CColour(0, 0, 0));
			aObelisk->SetAlpha(1.0f);
			break;
	}
}